(ns reagent-test.core
  (:require
   [reagent.core :as r]
   [reagent.dom :as d]
   [reagent-test.ncbi :refer [ncbi-search]]))

;; -------------------------
;; Component data (custom)

(def action-btns [{:text "file"
                   :items [{:text "new" :action #(dorun (js/console.log "test")
                                                        (js/console.log "hi"))}
                           {:text "new" :action #(js/alert "hi")}
                           {:text "quit" :action #()}]}
                  {:text "edit"
                   :items [{:text "hi" :action #(js/console.log "test2")}
                           {:text "bye" :action #(js/console.log "bye")}]}
                  {:text "view" :action #(js/console.log "test3")}
                  {:text "help" :action #(js/console.log "test4")}])

;; -------------------------
;; Menus

(defn dropdown-or-action
  "Render dropdown menu for an action button/menu"
  [btn-item is-dropdown]
  [:button {:class (if is-dropdown "menu-button" "")}
   :text (:text btn-item)
   :on-click (let [action (:action btn-item)]
               (if (nil? action)
                 #(dropdown-or-action btn-item true)
                 action))])

;; -------------------------
;; Views

(defn home-page []
  [:div
   [:h2 "Reagent Playground"]
   [:p "A groundbreaking, revolutionary app that does stuff."]
   [:div {:class "button-container"}
    (map (fn [btn] [:button
                    {:on-click #(dropdown-or-action btn false)}
                    (:text btn)]) action-btns)]])

;; -------------------------
;; Initialize app

(defn mount-root []
  (d/render [home-page] (.getElementById js/document "app")))

(defn ^:export init! []
  (mount-root))
