(ns reagent-test.ncbi
  (:require [clojure.core.async :refer [take!]]
            [goog.string :as gstring]
            [goog.string.format]))

(defn ncbi-search
  "Send search query to NCBI database.
   [More info](https://www.ncbi.nlm.nih.gov/books/NBK25500/#_chapter1_Searching_a_Database_)

   Example Query: `science[journal]+AND+breast+cancer+AND+2008[pdat]`"
  [query]
  (let [res (->> query
                 (gstring/format "https://eutils.ncbi.nlm.nih.gov/entrez/eutils/esearch.fcgi?db=pubmed&term=%s")
                 js/fetch
                 take!)]
    (js/console.log res)))
